structure Map =
    struct 
	exception MapOutofBounds of int * int;

	fun procrow (a::d) x w f cx =
	    if cx>=x andalso cx<(x+w) then
		(f a)::(procrow d x w f (cx+1))
	    else a::(procrow d x w f (cx+1))
	  | procrow nil x w f cx = nil;
		
	fun procmapboxhelper (a::d) x y w h f cy = 
	    if cy>=y andalso cy<(y+h) then 
		(procrow a x w f 0)::(procmapboxhelper d x y w h f (cy+1)) 
	    else a::(procmapboxhelper d x y w h f (cy+1))
	  | procmapboxhelper nil x y w h f cy = nil;

	fun procmapbox m x y w h f = procmapboxhelper m x y w h f 0;

	fun procxy m x y f = procmapbox m x y 1 1 f;

	fun createrow 0 = nil
	  | createrow w = (State.solid(State.unseen,State.nothing,State.nomonster))::createrow(w-1);
	fun createhelper w 0 = nil
	  | createhelper w h = createrow(w)::(createhelper w (h-1));
	fun create w h =
	    procmapbox (procmapbox (procmapbox (procmapbox
						(createhelper w h)
						0 0 w 1 (fn _ => State.border(State.unseen, 
									      State.nothing, 
									      State.nomonster)))
				    0 0 1 h (fn _ => State.border(State.unseen, State.nothing, State.nomonster)))
			(w-1) 0 1 h (fn _ => State.border(State.unseen, State.nothing, State.nomonster)))
	    0 (h-1) w 1 (fn _ => State.border(State.unseen, State.nothing, State.nomonster))

	fun getxy m x y =
	    List.nth(List.nth(m, y), x);

	fun getrowfromhelper m 0 = m
	  | getrowfromhelper nil x = raise MapOutofBounds (x, 0)
	  | getrowfromhelper (a::d) x = getrowfromhelper d (x-1);

	fun getrowfrom m x y =
	    getrowfromhelper (List.nth (m, y)) x;
				
	fun addroom m x y w h = 
	    procmapbox m x y w h (fn _ => State.floor(State.unseen, State.nothing, State.nomonster));
		     
	fun dispmaprow m 0 = ()
	  | dispmaprow nil w = raise MapOutofBounds (w, 0)
	  | dispmaprow (a::d) w =
	    (Curses.putch
	     (case a of
		  State.solid(State.seen, _, _) => #"#"
		| State.solid(State.unseen, _, _) => #" "
		| State.border(State.seen, _, _) => #"#"
		| State.border(State.unseen, _, _) => #" "
		| State.floor(State.seen, _, State.allosaur(_)) => #"A"
		| State.floor(State.seen, _, State.bat(_)) => #"B"
		| State.floor(State.seen, _, State.centaur(_)) => #"C"
		| State.floor(State.seen, _, State.dragon(_)) => #"D"
		| State.floor(State.seen, _, State.elemental(_)) => #"E"
		| State.floor(State.seen, State.money(_,_), _) => #"$"
		| State.floor(State.seen, State.armor(_,_), _) => #"]"
		| State.floor(State.seen, State.weapon(_,_), _) => #"/"
		| State.floor(State.seen, State.potion(_,_), _) => #"!"
		| State.floor(State.seen, State.scroll(_,_), _) => #"?"
		| State.floor(State.seen, _, _) => #"."
		| State.floor(State.unseen, _, _) => #" "
		| State.stairs(State.seen, _, _) => #">"
		| State.stairs(State.unseen, _, _) => #" ");
		  dispmaprow d (w-1));
	   
	fun dispmapbox m x y w 0 sx sy = ()
	  | dispmapbox m x y w h sx sy =
	    (Curses.gotoxy sx sy; 
	     dispmaprow (getrowfrom m x y) w;
	     dispmapbox m x (y+1) w (h-1) sx (sy+1))

	fun generateroom m x y w h s = 
	    let 
		val rw = Random.randRange (3,w) (Random.rand s);
		val rh = Random.randRange (3,h) (Random.rand((Random.randInt (Random.rand s), 
							      (case s of (x, y) => x))));
		val rx = Random.randRange (x,x+w-rw) (Random.rand(rw, rh));
		val ry = Random.randRange (y,y+h-rh) (Random.rand(rh, rx));
	    in
		addroom m rx ry rw rh
	    end;

	fun generatemaze_helper m w h nil s = m
	  | generatemaze_helper m w h ((x,y)::d) s = 
	    generatemaze_helper (generateroom m x y (w div 3) (h div 2) s) w h d
	    (Random.randInt (Random.rand s), (case s of (x, y) => x));

	fun generatetunnels m w h seed = 
	    let
		val y1 = Random.randRange (2, h div 2) (Random.rand seed);
		val y2 = Random.randRange (2, h div 2) (Random.rand (y1, 17));
		val y3 = Random.randRange (2, h div 2) (Random.rand (y2, y1));
		val y4 = Random.randRange (h div 2, h-2) (Random.rand (y2, y3));
		val y5 = Random.randRange (h div 2, h-2) (Random.rand (y3, y4));
		val y6 = Random.randRange (h div 2, h-2) (Random.rand (y4, y5));
	    in
		(* This is sick, but purely functional :) *)
		addroom (addroom 
			 (addroom 
			  (addroom 
			   (addroom 
			    (addroom 
			     (addroom 
			      (addroom 
			       (addroom 
				(addroom m 1 y1 (w div 3) 1)
				(w div 3) (if y1<y2 then y1 else y2) 1 ((if y1<y2 then y2-y1 else y1-y2)+1))
			       (w div 3) y2 ((w div 3)+1) 1)
			      (w*2 div 3) (if y2<y3 then y2 else y3) 1 ((if y2>y3 then y2-y3 else y3-y2)+1))
			     (w*2 div 3) y3 (w div 3) 1)
			    1 y4 (w div 3) 1)
			   (w div 3) (if y4<y5 then y4 else y5) 1 ((if y4>y5 then y4-y5 else y5-y4)+1))
			  (w div 3) y5 ((w div 3)+1) 1)
			 (w*2 div 3) (if y5<y6 then y5 else y6) 1 ((if y5>y6 then y5-y6 else y6-y5)+1))
		(w*2 div 3) y6 (w div 3) 1
	    end; 
	    
            fun addstairs m w h s = 
		let
		    val x = (Random.randRange (1, w-1) (Random.rand s))
		    val s2 = (Random.randInt (Random.rand s), (case s of (x, y) => x))
		    val y = (Random.randRange (1, h-1) (Random.rand s2));
		    val g = (getxy m x y);
		    val s3 = (Random.randInt (Random.rand s2), (case s2 of (x, y) => x))
		in
		    (*	print ("("^(Int.toString x)^", "^(Int.toString y)^")\n"); *)
		    case g of
			State.floor(n) => (procxy m x y (fn _ => State.stairs(n)))
		      | State.solid(_) => (addstairs m w h s3)
		      | State.border(_) => (addstairs m w h s3)
		      | State.stairs(_) => (addstairs m w h s3)
		end;

		     
	    fun additemshelper m seed 0 = m
	      | additemshelper m seed iter =
		let
		    val x = Random.randRange (1, 79) (Random.rand seed);
		    val seed2 = (Random.randInt (Random.rand seed), (case seed of (x, y) => x));
		    val y = Random.randRange (1, 22) (Random.rand seed2);
		    val seed3 = (Random.randInt (Random.rand seed2), (case seed2 of (x, y) => x));
		    val seed4 = (Random.randInt (Random.rand seed3), (case seed3 of (x, y) => x));
		in
		    case (getxy m x y) of
			State.solid(_,_,_) => additemshelper m seed3 iter
		      | State.border(_,_,_) => additemshelper m seed3 iter
		      | State.stairs(_,_,_) => additemshelper m seed3 iter
		      | State.floor(v, State.nothing, mon) => (additemshelper 
						  (procxy m x y (fn State.floor(v,_,_) => 
								 State.floor(v, Stuff.randitem seed4, mon)))
						  seed3 (iter-1))
		      | State.floor(_,_,_) => additemshelper m seed3 iter
		end;

	    fun additems m seed =
		let
		    val items = Random.randRange (2, 8) (Random.rand seed);
		    val seed2 = (Random.randInt (Random.rand seed), (case seed of (x, y) => x));
		in
		    additemshelper m seed2 items
		end;

	    fun placenmonsters m seed 0 = (m, nil, seed)
	      | placenmonsters m seed iter =
		let
		    val x = Random.randRange (1, 79) (Random.rand seed);
		    val seed2 = (Random.randInt (Random.rand seed), (case seed of (x, y) => x));
		    val y = Random.randRange (1, 22) (Random.rand seed2);
		    val seed3 = (Random.randInt (Random.rand seed2), (case seed2 of (x, y) => x));
		    val seed4 = (Random.randInt (Random.rand seed3), (case seed3 of (x, y) => x));
		in
		    case (getxy m x y) of
			State.solid(_,_,_) => placenmonsters m seed3 iter
		      | State.border(_,_,_) => placenmonsters m seed3 iter
		      | State.stairs(_,_,_) => placenmonsters m seed3 iter
		      | State.floor(_,_,State.nomonster) => 
			    let
				val newmons = Monster.randmonster x y seed4;
			    in
				case (placenmonsters 
				      (procxy m x y (fn State.floor(v,i,_) => 
						     State.floor(v, i, newmons)))
				      seed3 (iter-1)) of
				    (nm, mons, seed5) => (nm, newmons::mons, seed5)
			    end
		      | State.floor(_,_,_) => placenmonsters m seed3 iter
		end;

	    fun placerandmonster m seed = placenmonsters m seed 1;

	    fun addmonsters m seed =
		let
		    val mons = Random.randRange (3, 13) (Random.rand seed);
		    val seed2 = (Random.randInt (Random.rand seed), (case seed of (x, y) => x));
		in
		    placenmonsters m seed2 mons
		end;
    
	    fun generatemaze w h seed =
		let 
		    val seed2 = (Random.randInt (Random.rand seed), (case seed of (x, y) => x)) 
		    val seed3 = (Random.randInt (Random.rand seed2), (case seed2 of (x, y) => x)) 
		    val seed4 = (Random.randInt (Random.rand seed3), (case seed3 of (x, y) => x)) 
		in
		    additems (addstairs  (generatetunnels (generatemaze_helper (create w h) w h 
								 [(1,         1), 
								  (w div 3,   1),
								  (w*2 div 3, 1),
								  (1,         (h div 2)),
								  (w div 3,   (h div 2)),
								  (w*2 div 3, (h div 2))]
								 seed)
						w h seed2) w h seed3) seed4 
		end;
    end;

(* 
 use "../mines/map.sml"; 

 Map.dispmapbox (Map.procmapbox (Map.procmapbox (Map.create 5 5) 
 1 1 3 3 (fn _ => Map.State.solid(Map.State.seen)) 0) 
 2 2 1 1 (fn _ => Map.State.floor(Map.State.seen)) 0) 
 1 1 3 3 40 1; 

 (Curses.clear(); Map.dispmapbox (Map.generatemaze 80 23 30 10) 0 0 80 23 0 0; print "\n");
 (Curses.clear(); Map.dispmapbox (Map.generatemaze 80 23) 0 0 80 23 0 0; print "\n");
 (Curses.clear(); Map.dispmapbox (Map.generatetunnels (Map.generatemaze 80 23) 80 23) 0 0 80 23 0 0; print "\n");
 *)