structure Mines = 
    struct
	exception newlevel;
	exception monsterlistdesynched;

	fun topmessage s = (Curses.gotoxy 0 0;
			    print s);

	fun cleartop () = topmessage "                                                                                ";

	fun rolldice _ 0 _ = 0
	  | rolldice die rolls seed = 
	    let
		val seed2 = (Random.randInt (Random.rand seed), (case seed of (x, y) => x));
	    in
		(Random.randRange (1, die) (Random.rand seed)) + (rolldice die (rolls-1) seed2)
	    end;

	fun monsteract m st mons seed = 
	    let  
		val State.Status(px, py, php, phpmax, pstuff) = st;
	    in
		case mons of
		    State.nomonster => (m, st, mons, seed)
		  | _ =>
			let
			    val (mx, my, mhp, mhpmax, mdmg) = (case mons of 
							     State.allosaur(x, y, hp, hpmax, d) => (x, y, hp, hpmax, d)
							   | State.bat(x, y, hp, hpmax, d) => (x, y, hp, hpmax, d)
							   | State.centaur(x, y, hp, hpmax, d) => (x, y, hp, hpmax, d)
							   | State.dragon(x, y, hp, hpmax,d) => (x, y, hp, hpmax, d)
							   | State.elemental(x, y, hp, hpmax, d) => (x, y, hp, hpmax, d));
			    val xdf = (if mhp>(mhpmax div 4) then 1 else ~1) * (if px > mx then 1 else 
										    if px=mx then 0 else ~1);
			    val ydf = (if mhp>(mhpmax div 4) then 1 else ~1) * (if py > my then 1 else 
										    if py=my then 0 else ~1);
			in
			    if (mx+xdf)=px andalso (my+ydf)=py then
				let 
				    val (rolls, die) = mdmg;
				    val seed2 = (Random.randInt (Random.rand seed), (case seed of (x, y) => x))
				    val nhp = php - (rolldice die rolls seed);
				in
				    Curses.gotoxy 0 0;
				    print (case mons of
					       State.allosaur(_) =>  "The allosaur bites you!            "
					     | State.bat(_) =>       "The bat sucks your blood!          "
					     | State.centaur(_) =>   "The centaur tramples you!          "
					     | State.dragon(_) =>    "The dragon claws you!              "
					     | State.elemental(_) => "The elemental magically blasts you!");
				    if nhp<=0 then raise State.bailout(State.killed(mons))
				    else (m, State.Status(px, py, nhp, phpmax, pstuff), mons, seed2)
				end
			    else
				if (case (Map.getxy m (mx+xdf) (my+ydf)) of 
					State.floor(_,_,State.nomonster) => true | _ => false)
				    then let val newmons = (case mons of 
								State.allosaur(_, _, hp, hpmax, d) => 
								    State.allosaur(mx+xdf, my+ydf, hp, hpmax, d)
							      | State.bat(_, _, hp, hpmax, d) => 
								    State.bat(mx+xdf, my+ydf, hp, hpmax, d)
							      | State.centaur(_, _, hp, hpmax, d) => 
								    State.centaur(mx+xdf, my+ydf, hp, hpmax, d)
							      | State.dragon(_, _, hp, hpmax, d) => 
								    State.dragon(mx+xdf, my+ydf, hp, hpmax, d)
							      | State.elemental(_, _, hp, hpmax, d) => 
								    State.elemental(mx+xdf, my+ydf, hp, hpmax, d));
					 in
					     ((Map.procxy (Map.procxy m mx my (fn State.floor(v,i,_)=>
									       State.floor(v,i,State.nomonster)))
					       (mx+xdf) 
					       (my+ydf) 
					       (fn State.floor(v,i,_)=>State.floor(v,i, newmons))), 
					      st, newmons, seed)
					 end
				else if (case (Map.getxy m (mx+xdf) my) of 
					     State.floor(_,_,State.nomonster) => true | _ => false)
					 then let val newmons = (case mons of 
								     State.allosaur(_, _, hp, hpmax, d) => 
									 State.allosaur(mx+xdf, my, hp, hpmax, d)
								   | State.bat(_, _, hp, hpmax, d) => 
									 State.bat(mx+xdf, my, hp, hpmax, d)
								   | State.centaur(_, _, hp, hpmax, d) => 
									 State.centaur(mx+xdf, my, hp, hpmax, d)
								   | State.dragon(_, _, hp, hpmax, d) => 
									 State.dragon(mx+xdf, my, hp, hpmax, d)
								   | State.elemental(_, _, hp, hpmax, d) => 
									 State.elemental(mx+xdf, my, hp, hpmax, d));
					      in
						  ((Map.procxy (Map.procxy m mx my (fn State.floor(v,i,_)=>
										    State.floor(v,i,State.nomonster)))
						    (mx+xdf) 
						    my 
						    (fn State.floor(v,i,_)=>State.floor(v,i, newmons))), 
						   st, newmons, seed)
					      end
				     else if (case (Map.getxy m mx (my+ydf)) of 
						  State.floor(_,_,State.nomonster) => true | _ => false)
					      then let val newmons = (case mons of 
									  State.allosaur(_, _, hp, hpmax, d) => 
									      State.allosaur(mx, my+ydf, hp, hpmax, d)
									| State.bat(_, _, hp, hpmax, d) => 
									      State.bat(mx, my+ydf, hp, hpmax, d)
									| State.centaur(_, _, hp, hpmax, d) => 
									      State.centaur(mx, my+ydf, hp, hpmax, d)
									| State.dragon(_, _, hp, hpmax, d) => 
									      State.dragon(mx, my+ydf, hp, hpmax, d)
									| State.elemental(_, _, hp, hpmax, d) => 
									      State.elemental(mx, my+ydf, hp, hpmax, d));
						   in
						       ((Map.procxy (Map.procxy m mx my (fn State.floor(v,i,_)=>
											 State.floor(v,i,State.nomonster)))
							 mx 
							 (my+ydf) 
							 (fn State.floor(v,i,_)=>State.floor(v,i, newmons))), 
							st, newmons, seed)
						   end
					  else (m, st, mons, seed)
			end
	    end;

	fun domonsters m stat nil seed nmonst =
	    let
		val seed2 = (Random.randInt (Random.rand seed), (case seed of (x, y) => x));
		val seed3 = (Random.randInt (Random.rand seed2), (case seed of (x, y) => x));
	    in
		if (Random.randRange (~990, 10) (Random.rand seed2))>nmonst then
		    (case (Map.placerandmonster m seed3) of
			 (rm, rmons, rseed) => (rm, stat, rmons, rseed))
		else (m, stat, nil, seed3)
	    end
	  | domonsters m stat (a::d) seed nmonst =
	    let 
		val (nm, nstat, na, seed2) = monsteract m stat a seed;
	    in
		(case (domonsters nm nstat d seed2 nmonst) of
		     (dm, dstat, dmons, dseed) => (dm, dstat, na::dmons, dseed))
	    end;
	    
	fun otherstuff m stat mons seed = domonsters m stat mons seed (List.length(mons));

	fun playerattack _ _ _ _  nil seed = raise monsterlistdesynched
	  | playerattack m x y st (ma::md) seed = 
	    case (Map.getxy m x y) of
		State.floor(_, _, gxy) =>
		    if  gxy = ma then
			let
			    val (mx, my, mhp, mhpmax, mdmg) =  (case ma of 
								    State.allosaur(x, y, hp, hpmax, d) => 
									(x, y, hp, hpmax, d)
								  | State.bat(x, y, hp, hpmax, d) => 
									(x, y, hp, hpmax, d)
								  | State.centaur(x, y, hp, hpmax, d) => 
									(x, y, hp, hpmax, d)
								  | State.dragon(x, y, hp, hpmax,d) => 
									(x, y, hp, hpmax, d)
								  | State.elemental(x, y, hp, hpmax, d) => 
									(x, y, hp, hpmax, d));
			
			    val strike = rolldice 1 10 seed;
			    val nm = (if (mhp-strike)>0 then 
					  (case ma of 
					       State.allosaur(_, _, hp, hpmax, d) => 
						   State.allosaur(mx, my, mhp-strike, hpmax, d)
					     | State.bat(_, _, hp, hpmax, d) => 
						   State.bat(mx, my, mhp-strike, hpmax, d)
					     | State.centaur(_, _, hp, hpmax, d) => 
						   State.centaur(mx, my, mhp-strike, hpmax, d)
					     | State.dragon(_, _, hp, hpmax, d) => 
						   State.dragon(mx, my, mhp-strike, hpmax, d)
					     | State.elemental(_, _, hp, hpmax, d) => 
						   State.elemental(mx, my, mhp-strike, hpmax, d))
				      else State.nomonster);
			in		    
			    topmessage ("You strike the "^(Monster.descmonster ma)^(if nm=State.nomonster then
										   " and kill it!" else "!"));
			    if (mhp-strike)<(mhpmax div 4) andalso (mhp-strike)>0 then 
				print "  It flees for its life!" else ();
			    Curses.gotoxy 70 0;
			    print "-- more --";
			    Curses.getch();
			    cleartop();
			    (Map.procxy m x y (fn State.floor(v, i, _) => State.floor(v, i, nm)),
			     st,
			     if nm = State.nomonster then md else nm::md)
			end
		    else (case (playerattack m x y st md seed) of
			      (pm, pst, pmd) => (pm, pst, ma::pmd));

	fun usercmd m st mons seed = 
	    let 
		val State.Status(x, y, hp, hpmax, stuff) = st;
	    in
		case (let val g = Curses.getch(); in cleartop(); g end) of 
		    #"d" => (case (Map.getxy m (x-1) y) of
				 State.solid(_) => (m, st, mons)
			       | State.border(_) => (m, st, mons)
			       | State.floor(_,_,State.nomonster) =>
				     (m, State.Status(x-1, y, hp, hpmax, stuff), mons)
			       | State.floor(_,_,mst) => playerattack m (x-1) y st mons seed
			       | _ => (m, State.Status(x-1, y, hp, hpmax, stuff), mons))
		  | #"h" => (case (Map.getxy m x (y+1)) of
				 State.solid(_) => (m, st, mons)
			       | State.border(_) => (m, st, mons)
			       | State.floor(_,_,State.nomonster) =>
				     (m, State.Status(x, y+1, hp, hpmax, stuff), mons)
			       | State.floor(_,_,mst) => playerattack m x (y+1) st mons seed
			       | _ => (m, State.Status(x, y+1, hp, hpmax, stuff), mons))
		  | #"t" => (case (Map.getxy m x (y-1)) of
				 State.solid(_) => (m, st, mons)
			       | State.border(_) => (m, st, mons)
			       | State.floor(_,_,State.nomonster) =>
				     (m, State.Status(x, y-1, hp, hpmax, stuff), mons)
			       | State.floor(_,_,mst) => playerattack m x (y-1) st mons seed
			       | _ => (m, State.Status(x, y-1, hp, hpmax, stuff), mons))
		  | #"n" => (case (Map.getxy m (x+1) y) of
				 State.solid(_) => (m, st, mons)
			       | State.border(_) => (m, st, mons)
			       | State.floor(_,_,State.nomonster) =>
				     (m, State.Status(x+1, y, hp, hpmax, stuff), mons)
			       | State.floor(_,_,mst) => playerattack m (x+1) y st mons seed
			       | _ => (m, State.Status(x+1, y, hp, hpmax, stuff), mons))
		  | #"f" => (case (Map.getxy m (x-1) (y-1)) of
				 State.solid(_) => (m, st, mons)
			       | State.border(_) => (m, st, mons)
			       | State.floor(_,_,State.nomonster) =>
				     (m, State.Status(x-1, y-1, hp, hpmax, stuff), mons)
			       | State.floor(_,_,mst) => playerattack m (x-1) (y-1) st mons seed
			       | _ => (m, State.Status(x-1, y-1, hp, hpmax, stuff), mons))
		  | #"g" => (case (Map.getxy m (x+1) (y-1)) of
				 State.solid(_) => (m, st, mons)
			       | State.border(_) => (m, st, mons)
			       | State.floor(_,_,State.nomonster) =>
				     (m, State.Status(x+1, y-1, hp, hpmax, stuff), mons)
			       | State.floor(_,_,mst) => playerattack m (x+1) (y-1) st mons seed
			       | _ => (m, State.Status(x+1, y-1, hp, hpmax, stuff), mons))
		  | #"x" => (case (Map.getxy m (x-1) (y+1)) of
				 State.solid(_) => (m, st, mons)
			       | State.border(_) => (m, st, mons)
			       | State.floor(_,_,State.nomonster) =>
				     (m, State.Status(x-1, y+1, hp, hpmax, stuff), mons)
			       | State.floor(_,_,mst) => playerattack m (x-1) (y+1) st mons seed
			       | _ => (m, State.Status(x-1, y+1, hp, hpmax, stuff), mons))
		  | #"b" => (case (Map.getxy m (x+1) (y+1)) of
				 State.solid(_) => (m, st, mons)
			       | State.border(_) => (m, st, mons)
			       | State.floor(_,_,State.nomonster) =>
				     (m, State.Status(x+1, y+1, hp, hpmax, stuff), mons)
			       | State.floor(_,_,mst) => playerattack m (x+1) (y+1) st mons seed
			       | _ => (m, State.Status(x+1, y+1, hp, hpmax, stuff), mons))
		  | #"q" => raise State.bailout(State.quit)
		  | #"," => (case (Map.getxy m x y) of
				 State.solid(_) => (m, st, mons)
			       | State.border(_) => (m, st, mons)
			       | State.stairs(_) => (m, st, mons)
			       | State.floor(_,State.nothing, _) => (m, st, mons)
			       | State.floor(v,i,_) => (topmessage ("You pick up "^(Stuff.stuffdesc i));
						      (Map.procxy m x y (fn State.floor(v, i, m) => 
									State.floor(v, State.nothing, m)),
						      State.Status(x, y, hp, hpmax, i::stuff), mons)))
		  | #"s" => (Curses.clear();
			     Stuff.dispstuff stuff; 
			     Curses.getch(); 
			     Map.dispmapbox m 0 0 80 23 0 1; (m, st, mons))
		  | #"r" => (cleartop(); Map.dispmapbox m 0 0 80 23 0 1; (m, st, mons))
		  | #"D" => (topmessage "Direction to dig?";
			     let 
				 val nm =
				     (case Curses.getch() of
					  #"d" => (case (Map.getxy m (x-1) y) of
						       State.solid(_) => (Map.procxy m (x-1) y
									(fn _ => State.floor(State.seen, 
											     State.nothing,
											     State.nomonster)))
						     | _ => m)
					| #"n" => (case (Map.getxy m (x+1) y) of
						       State.solid(_) => (Map.procxy m (x+1) y  
									(fn _ => State.floor(State.seen, 
											     State.nothing,
											     State.nomonster)))
						     | _ => m)
					| #"t" => (case (Map.getxy m x (y-1)) of
						       State.solid(_) => (Map.procxy m x (y-1)
									(fn _ => State.floor(State.seen, 
											     State.nothing,
											     State.nomonster)))
						     | _ => m)
					| #"h" => (case (Map.getxy m x (y+1)) of
						       State.solid(_) => (Map.procxy m x (y+1)
									(fn _ => State.floor(State.seen, 
											     State.nothing,
											     State.nomonster)))
						     | _ => m)
					| #"f" => (case (Map.getxy m (x-1) (y-1)) of
						       State.solid(_) => (Map.procxy m (x-1) (y-1)
									(fn _ => State.floor(State.seen, 
											     State.nothing,
											     State.nomonster)))
						     | _ => m)
					| #"g" => (case (Map.getxy m (x+1) (y-1)) of
						       State.solid(_) => (Map.procxy m (x+1) (y-1)
									(fn _ => State.floor(State.seen, 
											     State.nothing,
											     State.nomonster)))
						     | _ => m)
					| #"x" => (case (Map.getxy m (x-1) (y+1)) of
						       State.solid(_) => (Map.procxy m (x-1) (y+1)
									(fn _ => State.floor(State.seen, 
											     State.nothing,
											     State.nomonster)))
						     | _ => m)
					| #"b" => (case (Map.getxy m (x+1) (y+1)) of
						       State.solid(_) => (Map.procxy m (x+1) (y+1)
									(fn _ => State.floor(State.seen, 
											     State.nothing,
											     State.nomonster)))
						     | _ => m)
					| _ => m);
			     in
				 cleartop();
				 (nm, State.Status(x, y, hp, hpmax, stuff), mons)
			     end)
		  | #">" => (case (Map.getxy m x y) of
				 State.stairs(_)=> raise newlevel 
			       | _ => (m, st, mons))
		  | _ => (m, st, mons)
	    end;

	fun main m (State.Status(x, y, hp, hpmax, stuff)) mons seed =
	    let
		val sx5 = (if x>2 then x-2 else 0);
		val sy5 = (if y>2 then y-2 else 0);
		val sx3 = (if x>1 then x-1 else 0);
		val sy3 = (if y>1 then y-1 else 0);
		val sw5 = (if x>75 then 82-x else 5);
		val sh5 = (if y>18 then 25-y else 5);
		val sw3 = (if x>77 then 81-x else 3);
		val sh3 = (if y>20 then 24-y else 3);
		val sm = (Map.procmapbox (Map.procmapbox m sx5 sy5 sw5 sh5 
					  (fn n => case n of 
					   State.solid(v,_,_) => State.solid(v, State.nothing, State.nomonster)
					 | State.border(v,_,_) => 
					       State.border(v, State.nothing, State.nomonster)
					 | State.floor(_, State.nothing, m) => State.floor(State.unseen, State.nothing, m)
					 | State.floor(v, i, State.nomonster) => State.floor(v, i, State.nomonster)
					 | State.floor(_, i, m) =>  State.floor(State.unseen, i, m)
					 | State.stairs(v,_,_) => 
					       State.stairs(v, State.nothing, State.nomonster)))
			  sx3 sy3 sw3 sw3 (fn n => case n of 
					   State.solid(_) => State.solid(State.seen, State.nothing, State.nomonster)
					 | State.border(_) => State.border(State.seen, State.nothing, State.nomonster)
					 | State.floor(_, i, m) => State.floor(State.seen, i, m)
					 | State.stairs(_) => State.stairs(State.seen, State.nothing, State.nomonster)));
		val seedu=(Random.randInt (Random.rand seed), (case seed of (x, y) => x));
	    in
		Map.dispmapbox sm sx5 sy5 sw5 sh5 sx5 (sy5+1);
		Curses.gotoxy 0 24;
		print ("HP: "^(Int.toString(hp))^"/"^(Int.toString(hpmax))^"    ");
		Curses.gotoxy x (y+1);
		print "@";
		Curses.gotoxy x y;
		let 
		    val (um, ustat, umons) = (usercmd sm (State.Status(x, y, hp, hpmax, stuff)) mons seedu);
		    val (om, ostat, omons, seed2) = (otherstuff um ustat umons seed);
		in
		    main om ostat omons seed2
		end 
	    handle 
	    newlevel => (enter (Map.generatemaze 80 23 seed) (State.Status(x, y, hp, hpmax, stuff)) seed)
	  | State.bailout(b) => b		    
	    end

	and (* main and enter are mutually recursive *)

	    enter m (State.Status(_, _, hp, hpmax, stuff)) seed = 
	    let
		val x = (Random.randRange (1, 79) (Random.rand seed));
		val seed2 = (Random.randInt (Random.rand seed), (case seed of (x, y) => x));
		val y = (Random.randRange (1, 22) (Random.rand seed2));
		val g = (Map.getxy m x y);
		val seed3 = (Random.randInt (Random.rand seed2), (case seed2 of (x, y) => x));
	    in
		case g of 
		    State.floor(_) => (Curses.clear(); 
				     (main m (State.Status(x, y, hp, hpmax, stuff)) nil seed3))
		  | State.border(_) => enter m (State.Status(x, y, hp, hpmax, stuff)) seed3
		  | State.stairs(_) => enter m (State.Status(x, y, hp, hpmax, stuff)) seed3
		  | State.solid(_) => enter m (State.Status(x, y, hp, hpmax, stuff)) seed3
	    end;

	fun splashscreen () =
	    (Curses.clear();
	     print "You have entered the Secret Mines of Legend!\n"; 
	     Curses.getch());
	    
	fun start () =
	    (Curses.rawmode();
	     Curses.echo_off();
	     Curses.invis_cursor();
	     splashscreen ();
	     let 
		 val seed = (Int32.toInt(Time.toSeconds(Time.now())), 
			     Int32.toInt(Time.toSeconds(Time.now())) mod 17707)
		 val seed2 = (Random.randInt (Random.rand seed), (case seed of (x, y) => x))
		 val r = enter (Map.generatemaze 80 23 seed) (State.Status(0, 0, 1000, 1000, nil)) seed2
	     in 
		 Curses.cookedmode();
		 Curses.echo_on();
		 Curses.vis_cursor();
		 Curses.clear();
		 r 
	     end);

	fun seededstart seed =
	    (Curses.rawmode();
	     Curses.echo_off();
	     splashscreen ();
	     let 
		 val seed2 = (Random.randInt (Random.rand seed), (case seed of (x, y) => x))
		 val r = enter (Map.generatemaze 80 23 seed) (State.Status(0, 0, 100, 100, nil)) seed2
	     in 
		 Curses.cookedmode();
		 Curses.echo_on();
		 Curses.clear();
		 r 
	     end);

    end;

(* 
use "curses.sml";
use "state.sml";
use "stuff.sml";
use "monster.sml";
use "map.sml";
use "mines.sml"; 

 Mines.start ();

*)