structure MyRandom = 
    struct
	val seed = ref (0,0);
	fun randInt () = 
	    let
		val x =
		    Random.randInt(Random.rand(if !seed = (0,0) then 
						   (seed := 
						    (Random.randInt(Random.rand(Int32.toInt(Time.toSeconds(Time.now())),
										0)), 
						     0);
						    !seed)
					       else !seed))
	    in
		seed := (x, #1(!seed));
		x
	    end;
    end;

structure Map = 
    struct
	val mapheight=23;
	val mapwidth=80;
	    
	datatype visible = seen | unseen;
	datatype mappoint = closeddoor of visible | opendoor of visible | solid of visible | floor of visible;
	type dungeonmap = mappoint array array;
	    
	fun clearmaphelper x c e = if c<e then (Array.update(x, c, Array.array(mapwidth, solid));
							 clearmaphelper x (c+1) e)
				       else x;
	fun clearmap x = clearmaphelper x 0 mapheight;
	fun mkblankmap () = clearmap(Array.array(mapheight, Array.array(1, solid(unseen))));
	    fun getxy a x y = Array.sub(Array.sub(a, y), x)
	fun updatexy a x y v = Array.update(Array.sub(a, y), x, v);
	fun displaymaprow m x y w = 
	    if w>0 then 
		(Curses.writeCharList 
		 (case (getxy m x y) of
	       | closeddoor(seen) => #"+"
	       | closeddoor(unseen) => #" "
	       | opendoor(seen) => #"-"
	       | opendoor(unseen) => #" "
	       | solid(seen) => #"#"
	       | solid(unseen) => #" "
	       | floor(seen) => #"."
	       | floor(unseen) => #" ");
		      displaymaprow m x y (w-1))
	    else ();
	fun displaymapblock m x y w h = if h>0 (gotoxy x y; 
						displaymaprow m x y w; 
						displaymapblock m x (y+1) w h)
	fun markvisible m x y = updatexy m x y 
	    case (getxy a x y) of
		 closedoor(_) => closedoor(seen)
	       | opendoor(_) => opendoor(seen)
	       | solid(_) => opendoor(seen)
	       | floor(_) => opendoor(seen)		     
end;